/*
	* OpmlCreate.aspx.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved. 
*/

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Reflection;
using System.Resources; 
using Web20Tools.Opml;   
using Web20Tools.Security; 
using Web20Tools.ExceptionFramework; 

namespace Samples.Opml
{
	/// <summary>
	/// Create an OPML feed.
	/// </summary>
	public class OpmlCreate : System.Web.UI.Page
	{
        protected System.Web.UI.HtmlControls.HtmlForm Form1;
        protected System.Web.UI.WebControls.Label lblCreated;
        protected System.Web.UI.WebControls.HyperLink hlOpenXMLtop;
        protected System.Web.UI.WebControls.DropDownList ddlVersions;
        protected System.Web.UI.WebControls.Button btnCreate;
        protected System.Web.UI.WebControls.Label lblMsg;
        protected System.Web.UI.WebControls.Label lblCreatedBottom;
        protected System.Web.UI.WebControls.HyperLink hlOpenXML;
		protected System.Web.UI.WebControls.TextBox txtHeadTitle;
		protected System.Web.UI.WebControls.TextBox txtOutlineText;
		protected System.Web.UI.WebControls.TextBox txtOutlineDesc;
		protected System.Web.UI.WebControls.TextBox txtOutlineTitle;
		protected System.Web.UI.WebControls.TextBox txtOwner;
		protected System.Web.UI.WebControls.Label lblOwnerId;
		protected System.Web.UI.WebControls.Label lblIdColon;
		protected System.Web.UI.WebControls.TextBox txtOwnerId;
        protected System.Web.UI.WebControls.HyperLink hlViewError;
        protected System.Web.UI.WebControls.Label lblError;

		private ResourceManager stringManager = new ResourceManager("Samples.SamplesResource",Assembly.GetExecutingAssembly()); 
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			
			if(!IsPostBack)
			{
				ddlVersions.Attributes.Add("OnChange", "return showVersion();");
				loadDefaultValues();                
#if VS8 
                ClientScript.RegisterStartupScript(Type.GetType("System.String"), "Start", "<script language=JavaScript>showVersion();</script>");
#else
                RegisterStartupScript("Start", "<script language=JavaScript>showVersion();</script>");
#endif
				fillVersions();
				btnCreate.Attributes.Add("OnClick","return clearLables();");
                hlViewError.Attributes.Add("OnClick", "return ShowError();");
			}
					
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{   

		}
		#endregion

		#region Save Method
		private void saveOpmlFeed()
		{
			try
			{
                License.LoadLicense();
				OpmlDoc doc = new OpmlDoc();
			
				doc.Version = ddlVersions.SelectedItem.Text;
				doc.Head.Title = txtHeadTitle.Text; 
				doc.Head.OwnerName = txtOwner.Text;  
				doc.Head.DateCreated = DateTime.Now.ToString();
                if (ddlVersions.SelectedItem.Text.Equals("2.0"))
                {
                    if (!txtOwnerId.Text.ToUpper().StartsWith("http://".ToUpper()))
                        txtOwnerId.Text = "http://" + txtOwnerId.Text;
                    doc.Head.OwnerId = txtOwnerId.Text;
                }
                
				Outline objOutline = new Outline();

				objOutline.Text = txtOutlineText.Text;
				objOutline.Title = txtOutlineTitle.Text;
				objOutline.Description = txtOutlineDesc.Text;
  	
				doc.Body.Outlines.Add(objOutline);
				
				Session.Add("FeedShow",doc);

				lblCreated.Text = stringManager.GetString("strCreated");
				lblCreatedBottom.Text = stringManager.GetString("strCreated");
				hlOpenXML.Text = stringManager.GetString("strClick");
				hlOpenXMLtop.Text = stringManager.GetString("strClick"); 
				hlOpenXML.NavigateUrl = "OpmlShowFeed.aspx";
				hlOpenXMLtop.NavigateUrl = "OpmlShowFeed.aspx";
				hlOpenXML.Target = "_blank";
				hlOpenXMLtop.Target = "_blank"; 
				lblMsg.Text = stringManager.GetString("strBlank");

                hlViewError.Text = stringManager.GetString("strBlank");
                hlViewError.NavigateUrl = stringManager.GetString("strBlank");
                lblError.Text = stringManager.GetString("strBlank");
			}
			catch (InvalidLicenseException ilex)
			{
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank");
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");

				lblMsg.Text = stringManager.GetString("strLicenseException");
				Session["FeedShow"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ilex.Message;
			}
            catch (InvalidLicenseInfoException iliex)
            {
                lblCreated.Text = stringManager.GetString("strBlank");
                lblCreatedBottom.Text = stringManager.GetString("strBlank");
                hlOpenXML.Text = stringManager.GetString("strBlank");
                hlOpenXMLtop.Text = stringManager.GetString("strBlank");

                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo");
                Session["FeedShow"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = iliex.Message;
            }
			catch(Exception ex)
			{
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank");
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				lblMsg.Text = stringManager.GetString("strErrorCreating");
				Session["FeedShow"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}
		}
		#endregion

		private void loadDefaultValues()
		{
			txtHeadTitle.Text = stringManager.GetString("strHeadTitle");
			txtOwner.Text = stringManager.GetString("strOwner");
			txtOwnerId.Text = stringManager.GetString("strOwnerId");
			txtOutlineText.Text = stringManager.GetString("strText");
			txtOutlineTitle.Text = stringManager.GetString("strTitle");
			txtOutlineDesc.Text = stringManager.GetString("strDesc");
		}

		

		#region Private Methods
		private void fillVersions()
		{
			ddlVersions.Items.Add("1.0");
			ddlVersions.Items.Add("2.0");
		}
		#endregion

		protected void btnCreate_Click(object sender, System.EventArgs e)
		{
			saveOpmlFeed();
#if VS8 
            ClientScript.RegisterStartupScript(Type.GetType("System.String"), "Start", "<script language=JavaScript>showVersionDiv();</script>");
#else
			RegisterStartupScript("Start", "<script language=JavaScript>showVersionDiv();</script>");
#endif
		}
	}
}
