<%@ Page Language="c#" Inherits="Samples.Opml.OpmlLoad" Codebehind="OpmlLoad.aspx.cs" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<html>
<head>
    <title>Web20Tools Samples - How to read and display different versions of OPML feeds</title>
    <style type="text/css">
        td { font-family:verdana; font-size:12px;}    
        </style>
    <meta content="Microsoft Visual Studio .NET 7.1" name="GENERATOR">
    <meta content="C#" name="CODE_LANGUAGE">
    <meta content="JavaScript" name="vs_defaultClientScript">
    <meta content="http://schemas.microsoft.com/intellisense/ie5" name="vs_targetSchema">

    <script language="javascript">
		function trimString (str) 
		{
			str = this != window? this : str;
			return str.replace(/^\s+/g, '').replace(/\s+$/g, '');
		}
		
		function ShowError()
		{		    
		    document.getElementById("divError").style.display="block";
		    document.getElementById("divError").style.position="absolute";
		    document.getElementById("divError").style.top="430px";
		    document.getElementById("divError").style.left="450px";
		    return false;
		}
		
		function checkURL()
		{		
			if(document.getElementById("rdSelectUrl").checked==false && (trimString(document.getElementById("txtUrl").value) == "" || trimString(document.getElementById("txtUrl").value) == "http://") )
			{
				document.getElementById("lblMsg").innerHTML = "Please Enter Feed URL.";
				if(document.getElementById("txtUrl").disabled == false)
					document.getElementById("txtUrl").focus();
				
				return false;
			}
			else
			{
				document.getElementById("lblMsg").innerHTML = "";
				document.getElementById("hlViewError").innerHTML = "";
				return true;
			}
			
		}
		
		function EnableDisableURLControls()
		{
			if(document.getElementById("rdSelectUrl").checked==true)
			{
				document.getElementById("txtUrl").value = "http://";
				document.getElementById("txtUrl").disabled = true;
				document.getElementById("ddlURL").disabled = false;
				if(document.getElementById("dgRssFeed"))
					document.getElementById("dgRssFeed").style.display = "none";
				if(document.getElementById("dgItem"))
					document.getElementById("dgItem").style.display = "none"; 
				document.getElementById("lblEntry").innerHTML  = ""; 
				document.getElementById("lblFeed").innerHTML  = "";
			}
			else
			{	
				document.getElementById("txtUrl").disabled = false;
				document.getElementById("ddlURL").disabled = true;
				if(document.getElementById("dgRssFeed"))
					document.getElementById("dgRssFeed").style.display = "none";
				if(document.getElementById("dgItem"))
					document.getElementById("dgItem").style.display = "none";
				document.getElementById("lblEntry").innerHTML  = ""; 
				document.getElementById("lblFeed").innerHTML  = "";
				setFocus();
			}
			return true;
		}
		
		function setFocus()
		{
			document.getElementById("txtUrl").focus();
			return true;
		}
    </script>

</head>
<body bgcolor="#BDC7DA" style="font-family: Verdana; font-size: 12px;">
    <form id="SampleForm" method="post" runat="server">
        <table width="100%">
            <tr>
                <td align="center">
                    <table width="75%" bgcolor="white" cellspacing="10" style="border: solid 2px black;">
                        <tr>
                            <td colspan="3">
                                <a href="http://www.web20tools.net">Web 2.0 Tools for .NET Developers</a>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="3">
                                <table align="right">
                                    <tr>
                                        <td>
                                            <p>
                                                <a href="../OpmlMenuIndex.htm">Index </a>&nbsp; &nbsp; <a href="OpmlStream.aspx">Next</a>&nbsp;&nbsp;&nbsp;</p>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="3">
                                <h2>
                                    How to read and display different versions of OPML feeds</h2>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="3" bgcolor="#f0f0f0" style="border: solid 1px black; padding-left: 20px;
                                padding-right: 20px;">
                                <table width="100%">
                                    <tr>
                                        <td colspan="3">
                                            The following sample shows the capability of OPML.NET to load different versions
                                            of OPML feeds. The current version (2.0.0.0) supports reading OPML 1.0 and 2.0 feeds.
                                        </td>
                                    </tr>
                                    <tr>
                                        <td colspan="3" style="text-align: justify;">
                                            <b>Description</b><br />
                                            The following sample reads an OPML feed either from the pre-configured list or from
                                            a URL of your choice. The drop down list has a pre-configured list of OPML feeds
                                            that you can select. If you would like to read a feed of your choice, enter the
                                            URL in the text box below. Click on the <b>Load</b> button.
                                            <br />
                                            <br />
                                            The sample application will load the FEED you have entered/selected and will display
                                            the information in a table below. If the body has multiple outlines, only the first
                                            outline will be displayed.
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td valign="top" width="25%">
                                <b>
                                    <asp:RadioButton ID="rdSelectUrl" runat="server" CssClass="OptionButton" Text="Select Feed URL"
                                        GroupName="AtomURL"></asp:RadioButton></b></td>
                            <td valign="top" width="1%">
                            </td>
                            <td valign="top">
                                <asp:DropDownList ID="ddlURL" runat="server" CssClass="DropDown_large" Width="100%">
                                </asp:DropDownList></td>
                        </tr>
                        <tr>
                            <td valign="top">
                                <b>
                                    <asp:RadioButton ID="rdEnterUrl" runat="server" CssClass="OptionButton" Text="Enter Feed URL"
                                        GroupName="AtomURL"></asp:RadioButton></b></td>
                            <td valign="top">
                            </td>
                            <td valign="top">
                                <asp:TextBox ID="txtUrl" runat="server" CssClass="TextBox_large" Width="100%">http://</asp:TextBox></td>
                        </tr>                        
                        <tr>
                            <td>
                            </td>
                            <td>
                            </td>
                            <td>
                                <asp:Button ID="btnLoad" runat="server" CssClass="Button" Text="Load" OnClick="btnLoad_Click">
                                </asp:Button>&nbsp;
                                <asp:Label ID="lblMsg" runat="server" CssClass="ErrorMsg" ForeColor="Red"></asp:Label>
                                <asp:HyperLink ID="hlViewError" runat="server"></asp:HyperLink>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="3">
                                <a name="#bm"></a><b>
                                    <asp:Label ID="lblFeed" runat="server"></asp:Label></b></td>
                        </tr>
                        <tr>
                            <td align="center" colspan="3">
                                <asp:DataGrid ID="dgRssFeed" runat="server" CssClass="datagrid_style" Width="100%"
                                    ForeColor="Black" BorderColor="black" BorderStyle="Solid" CellSpacing="0" BorderWidth="1px"
                                    BackColor="#CCCCCC" CellPadding="2">
                                    <SelectedItemStyle Font-Bold="True" ForeColor="White" BackColor="#000099"></SelectedItemStyle>
                                    <ItemStyle BackColor="White"></ItemStyle>
                                    <HeaderStyle Font-Bold="True" ForeColor="White" BackColor="Maroon"></HeaderStyle>
                                    <FooterStyle BackColor="#CCCCCC"></FooterStyle>
                                    <PagerStyle HorizontalAlign="Left" ForeColor="Black" BackColor="#CCCCCC" Mode="NumericPages">
                                    </PagerStyle>
                                </asp:DataGrid></td>
                        </tr>                        
                        <tr>
                            <td colspan="3">
                                <b>
                                    <asp:Label ID="lblEntry" runat="server"></asp:Label></b></td>
                        </tr>
                        <tr>
                            <td align="center" colspan="3">
                                <asp:DataGrid ID="dgItem" runat="server" CssClass="datagrid_style" Width="100%" BorderColor="black"
                                    BorderStyle="Solid" CellSpacing="0" BorderWidth="1px" BackColor="#CCCCCC" CellPadding="2">
                                    <HeaderStyle Font-Bold="True" ForeColor="White" BackColor="Maroon"></HeaderStyle>
                                    <ItemStyle BackColor="White"></ItemStyle>
                                </asp:DataGrid></td>
                        </tr>
                        <tr>
                            <td colspan="3">
                                <a href="../OpmlMenuIndex.htm">&lt;&lt; Back to OPML.NET Samples </a>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="3">
                                <div id="divError" style="display: none; width: 270px; background-color: White; border: solid 2px"
                                    runat="server">
                                    <table width="100%">
                                        <tr>
                                            <td align="right">
                                                <a href="#" onclick="document.getElementById('divError').style.display='none';">Close</a>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="labelError">
                                                <asp:Label ID="lblError" runat="server"></asp:Label>
                                            </td>
                                        </tr>
                                    </table>
                                </div>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
        <center>
            Copyright  2002 - 2008 ToolButton Inc. All rights reserved.</center>
    </form>
</body>
</html>
