/*
	* OpmlLoad.aspx.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved. 
*/

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Net; 
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Web20Tools.Opml; 
using System.Reflection;
using System.Resources;
using System.Text; 
using Web20Tools.Security;  
using Web20Tools.ExceptionFramework; 

namespace Samples.Opml
{
	/// <summary>
	/// Read and display different versions of OPML feeds.
	/// </summary>
	public class OpmlLoad : System.Web.UI.Page
	{
        protected System.Web.UI.HtmlControls.HtmlForm SampleForm;
        protected System.Web.UI.WebControls.RadioButton rdSelectUrl;
        protected System.Web.UI.WebControls.DropDownList ddlURL;
        protected System.Web.UI.WebControls.RadioButton rdEnterUrl;
        protected System.Web.UI.WebControls.TextBox txtUrl;
        protected System.Web.UI.WebControls.Button btnLoad;
        protected System.Web.UI.WebControls.Label lblMsg;
        protected System.Web.UI.WebControls.Label lblFeed;
        protected System.Web.UI.WebControls.DataGrid dgRssFeed;
        protected System.Web.UI.WebControls.Label lblEntry;
        protected System.Web.UI.WebControls.DataGrid dgItem;
        protected System.Web.UI.WebControls.HyperLink hlViewError;
        protected System.Web.UI.WebControls.Label lblError;
		protected System.Web.UI.HtmlControls.HtmlGenericControl divError;

		private ResourceManager stringManager = new ResourceManager("Samples.SamplesResource",Assembly.GetExecutingAssembly());
			
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			if(!IsPostBack)
			{
				LoadAttributes();
                hlViewError.Attributes.Add("OnClick", "return ShowError();");
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.dgRssFeed.ItemCreated += new System.Web.UI.WebControls.DataGridItemEventHandler(this.dgRssFeed_ItemCreated);
			this.dgItem.ItemCreated += new System.Web.UI.WebControls.DataGridItemEventHandler(this.dgItem_ItemCreated);

		}
		#endregion

		protected void btnLoad_Click(object sender, System.EventArgs e)
		{
			OpmlDoc doc = null; 
			DataSet ds = new DataSet();
			ds.Locale = System.Globalization.CultureInfo.InvariantCulture;
            try
            {
                License.LoadLicense();
                if (rdSelectUrl.Checked)
                {
                    doc = OpmlDoc.Load(ddlURL.SelectedValue.ToString());
                    ddlURL.Enabled = true;
                    txtUrl.Enabled = false;
                    txtUrl.Text = stringManager.GetString("strHttp");
                }
                else
                {
                    if (!txtUrl.Text.ToUpper().StartsWith("http://".ToUpper()))
                        txtUrl.Text = "http://" + txtUrl.Text;
                    doc = OpmlDoc.Load(txtUrl.Text);
                    txtUrl.Enabled = true;
                    ddlURL.Enabled = false;
                }

                ds = OpmlLoadGrid(doc);
                dgRssFeed.DataSource = ds.Tables[0];
                dgRssFeed.DataBind();

                dgItem.DataSource = ds.Tables[1];
                dgItem.DataBind();                   
                

                lblFeed.Text = stringManager.GetString("strHeadGridTitle");
                lblEntry.Text = stringManager.GetString("strBodyGridTitle");
                dgRssFeed.Visible = true;
                dgItem.Visible = true;
                lblMsg.Text = stringManager.GetString("strBlank");

                hlViewError.Text = stringManager.GetString("strBlank");
                hlViewError.NavigateUrl = stringManager.GetString("strBlank");
                lblError.Text = stringManager.GetString("strBlank");

                Response.Write("<script language=javascript>window.navigate('#bm');</script>");
            }
            catch (OpmlException ex)
            {
                txtUrl.Enabled = false;
                txtUrl.Text = stringManager.GetString("strHttp");
                rdSelectUrl.Checked = true;
                rdEnterUrl.Checked = false;

                if (ex.Message == stringManager.GetString("strUnlicensed"))
                    lblMsg.Text = stringManager.GetString("strLicenseException");
                else
                    lblMsg.Text = stringManager.GetString("strErrorReading");
                lblFeed.Text = stringManager.GetString("strBlank");
                lblEntry.Text = stringManager.GetString("strBlank");
                dgRssFeed.Visible = false;
                dgItem.Visible = false;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
            }
            catch (InvalidLicenseInfoException iliex)
            {
                txtUrl.Enabled = false;
                txtUrl.Text = stringManager.GetString("strHttp");
                rdSelectUrl.Checked = true;
                rdEnterUrl.Checked = false;

                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo");
                lblFeed.Text = stringManager.GetString("strBlank");
                lblEntry.Text = stringManager.GetString("strBlank");
                dgRssFeed.Visible = false;
                dgItem.Visible = false;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = iliex.Message;
            }
            catch (InvalidLicenseException ilex)
            {
                txtUrl.Enabled = false;
                txtUrl.Text = stringManager.GetString("strHttp");
                rdSelectUrl.Checked = true;
                rdEnterUrl.Checked = false;

                lblMsg.Text = stringManager.GetString("strLicenseException");
                lblFeed.Text = stringManager.GetString("strBlank");
                lblEntry.Text = stringManager.GetString("strBlank");
                dgRssFeed.Visible = false;
                dgItem.Visible = false;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ilex.Message;
            }
            catch (Exception ex)
            {
				ex.Message.ToString();  
                txtUrl.Enabled = false;
                txtUrl.Text = stringManager.GetString("strHttp");
                rdSelectUrl.Checked = true;
                rdEnterUrl.Checked = false;

                lblMsg.Text = stringManager.GetString("strErrorReading");
                lblFeed.Text = stringManager.GetString("strBlank");
                lblEntry.Text = stringManager.GetString("strBlank");
                dgRssFeed.Visible = false;
                dgItem.Visible = false;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
            }  
		
		}

		#region OpmlFeed
		private DataSet OpmlLoadGrid(OpmlDoc doc)
		{
			DataSet dsOpml = new DataSet();
			dsOpml.Locale = System.Globalization.CultureInfo.InvariantCulture;
			DataTable  dt = new DataTable("OpmlTable"); 
            dt.Locale = System.Globalization.CultureInfo.InvariantCulture;

			DataTable  dti = new DataTable("OutlineTable");
			dti.Locale = System.Globalization.CultureInfo.InvariantCulture;
				  
			DataColumn tagCol = new DataColumn("Element",System.Type.GetType("System.String") );
			dt.Columns.Add(tagCol);
			
			DataColumn attributeCol = new DataColumn("Attribute/Tag",System.Type.GetType("System.String") );
			dt.Columns.Add(attributeCol);			

			DataColumn valueCol = new DataColumn("Value",System.Type.GetType("System.String") );
			dt.Columns.Add(valueCol);

			DataRow dr;

			dr = dt.NewRow();
			dr["Attribute/Tag"] = "Version";
			dr["Value"] = doc.Version;   
			dt.Rows.Add(dr);

			if (doc.Head.Title != null)           
			{
				dr = dt.NewRow();
				dr["Element"] = "Title";
				dr["Value"] = doc.Head.Title; 
				dt.Rows.Add(dr);  
			}
			
			if (doc.Head.DateCreated != null)
			{
				dr = dt.NewRow();
				dr["Element"] = "Date Created";
				dr["Value"] = doc.Head.DateCreated;   
				dt.Rows.Add(dr);  
			}
			if (doc.Head.DateModified != null)
			{
				dr = dt.NewRow();
				dr["Element"] = "Date Modified";
				dr["Value"] = doc.Head.DateModified;
				dt.Rows.Add(dr); 
			}
		    
			if (doc.Head.OwnerName != null)
			{
				dr = dt.NewRow();
				dr["Element"] = "Owner Name";
				dr["Value"] = doc.Head.OwnerName;
				dt.Rows.Add(dr); 
			}

			if (doc.Head.OwnerEmail != null)
			{
				dr = dt.NewRow();
				dr["Element"] = "Owner Email";
				dr["Value"] = doc.Head.OwnerEmail;
				dt.Rows.Add(dr); 
			}
			
			if (doc.Head.ExpansionState != null)
			{
				if (doc.Head.ExpansionState.Length != 0)
				{
					dr = dt.NewRow();
					dr["Element"] = "Expansion State";
					dr["Value"] = doc.Head.ExpansionState;
					dt.Rows.Add(dr); 
				}
			}

			if (doc.Head.VertScrollState != null)
			{
				dr = dt.NewRow();
				dr["Element"] = "VertScrollState";
				dr["Value"] = doc.Head.VertScrollState; 
				dt.Rows.Add(dr); 
			}
			
			if (doc.Head.WindowTop != null)
			{
				dr = dt.NewRow();
				dr["Element"] = "Window Top";
				dr["Value"] = doc.Head.WindowTop;  
				dt.Rows.Add(dr); 
			}

			if (doc.Head.WindowLeft != null)
			{
				dr = dt.NewRow();
				dr["Element"] = "Window Left";
				dr["Value"] = doc.Head.WindowLeft; 
				dt.Rows.Add(dr); 
			}

			if (doc.Head.WindowBottom != null)
			{
				dr = dt.NewRow();
				dr["Element"] = "Window Bottom";
				dr["Value"] = doc.Head.WindowBottom;
				dt.Rows.Add(dr); 
			}

			if (doc.Head.WindowRight != null)
			{
				dr = dt.NewRow();
				dr["Element"] = "Window Right";
				dr["Value"] = doc.Head.WindowRight;
				dt.Rows.Add(dr); 
			}

			if (doc.Head.OwnerId != null)
			{
				dr = dt.NewRow();
				dr["Element"] = "Owner Id";
				dr["Value"] = doc.Head.OwnerId;
				dt.Rows.Add(dr); 
			}
			
			if (doc.Head.Docs != null)
			{
				dr = dt.NewRow();
				dr["Element"] = "Docs";
				dr["Value"] = doc.Head.Docs;
				dt.Rows.Add(dr); 
			}
			
			dti = OpmlGridOutline(doc.Body.Outlines);
			
			dsOpml.Tables.Add(dt);  
			dsOpml.Tables.Add(dti);  
			
			return dsOpml;
		}


		private DataTable OpmlGridOutline(OutlineCollection outlineCol)
		{
			DataTable  dti = new DataTable();
			dti.Locale = System.Globalization.CultureInfo.InvariantCulture;
			DataColumn tagCol = new DataColumn("Element",System.Type.GetType("System.String"));
			dti.Columns.Add(tagCol);

			DataColumn attributeCol = new DataColumn("Attribute/Tag",System.Type.GetType("System.String") );
			dti.Columns.Add(attributeCol);

			DataColumn valueCol = new DataColumn("Value",System.Type.GetType("System.String") );
			dti.Columns.Add(valueCol);

			DataRow dr;
			
			foreach (Outline objOutline in outlineCol)
			{
				dr = dti.NewRow();
				dr["Element"] = "Outline";
				dti.Rows.Add(dr); 

				if (objOutline.Title != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "Title";
					dr["Value"] = objOutline.Title;
					dti.Rows.Add(dr); 
				}
 
				if (objOutline.Text != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "Text";
					dr["Value"] = XMLEncoding(objOutline.Text);
					dti.Rows.Add(dr); 
				}
				
				if (objOutline.Description != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "Description";
					dr["Value"] = XMLEncoding(objOutline.Description);
					dti.Rows.Add(dr); 
				}
				
				if (objOutline.Type != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "Type";
					dr["Value"] = objOutline.Type;
					dti.Rows.Add(dr);
				}

				if (objOutline.Language != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "Languge";
					dr["Value"] = objOutline.Language;
					dti.Rows.Add(dr);
				}

				if (objOutline.Version != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "Version";
					dr["Value"] = objOutline.Version;
					dti.Rows.Add(dr);						
				}

				if (objOutline.Category != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "Category";
					dr["Value"] = objOutline.Category;
					dti.Rows.Add(dr);
				}
				
				if (objOutline.HTMLURL != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "Html Url";
					dr["Value"] = objOutline.HTMLURL;
					dti.Rows.Add(dr);
				}
				if (objOutline.XMLURL != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "Xml Url";
					dr["Value"] = objOutline.XMLURL;
					dti.Rows.Add(dr);
				}
				if (objOutline.Created != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "Created";
					dr["Value"] = objOutline.Created;
					dti.Rows.Add(dr);
				}
				if (objOutline.IsBreakPoint != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "IsBreakPoint";
					dr["Value"] = objOutline.IsBreakPoint;
					dti.Rows.Add(dr);
				}
				if (objOutline.IsComment != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "IsComment";
					dr["Value"] = objOutline.IsComment;
					dti.Rows.Add(dr);
				}

				if (objOutline.Url != null)
				{
					dr = dti.NewRow();
					dr["Attribute/Tag"] = "Url";
					dr["Value"] = objOutline.Url;
					dti.Rows.Add(dr);
				}
				
				break;
			}
			
			return dti;
		}
		#endregion

		
       
		#region Grid Events
		
		private void dgRssFeed_ItemCreated(object sender, DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				e.Item.Cells[0].Width = Unit.Percentage(15);
				e.Item.Cells[0].BackColor = System.Drawing.Color.Cornsilk;

				e.Item.Cells[1].Width = Unit.Percentage(15);
				e.Item.Cells[1].ForeColor = System.Drawing.Color.Blue;

				e.Item.Cells[2].Width = Unit.Percentage(70);
				e.Item.Cells[2].ForeColor = System.Drawing.Color.Red;
			}

		}
 
		private void dgItem_ItemCreated(object sender, DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				e.Item.Cells[0].Width = Unit.Percentage(15);
				e.Item.Cells[0].BackColor = System.Drawing.Color.Cornsilk;

				e.Item.Cells[1].Width = Unit.Percentage(15);
				e.Item.Cells[1].ForeColor = System.Drawing.Color.Blue;

				e.Item.Cells[2].Width = Unit.Percentage(70);
				e.Item.Cells[2].ForeColor = System.Drawing.Color.Red;
			}
		}
		
		#endregion
		
		#region Page Load Methods
		private void  LoadAttributes()
		{			
			fillURLs();
			txtUrl.Enabled = false;
			txtUrl.Text = stringManager.GetString("strHttp");
			rdSelectUrl.Checked = true;
			lblFeed.Text = stringManager.GetString("strBlank");
			lblEntry.Text = stringManager.GetString("strBlank");
			rdSelectUrl.Attributes.Add("OnClick","return EnableDisableURLControls();");
			rdEnterUrl.Attributes.Add("OnClick","return EnableDisableURLControls();");
			btnLoad.Attributes.Add("OnClick","return checkURL();");
		}

		private void fillURLs()
		{
			ddlURL.Items.Add(new ListItem(stringManager.GetString("strOpml10Url"), stringManager.GetString("strOpml10Url")));
			ddlURL.Items.Add(new ListItem(stringManager.GetString("strOpml20Url"), stringManager.GetString("strOpml20Url")));					
		}

		#endregion

		
		private string XMLEncoding(string stitle)
		{
            StringBuilder strBuild = new StringBuilder(stitle);

            strBuild.Replace("&amp;", "")
                .Replace("&apos;", "'")
                .Replace("&quot;", "\"")
                .Replace("&lt;", "<")
                .Replace("&gt;", ">")
                .Replace("\n", "")
                .Replace("\r", "");

            return strBuild.ToString().Trim();   
				
		}
	}
}
