/*
	* OpmlStream.aspx.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved. 
*/

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Web20Tools.Opml; 
using System.Reflection;
using System.Resources;
using Web20Tools.Security; 
using Web20Tools.ExceptionFramework;

namespace Samples.Opml
{
	/// <summary>
	/// Write an OPML Feed to an HTTP Response Stream.
	/// </summary>
	public class OpmlStream : System.Web.UI.Page
	{
        protected System.Web.UI.HtmlControls.HtmlForm Form1;
        protected System.Web.UI.WebControls.RadioButton rdSelectUrl;
        protected System.Web.UI.WebControls.DropDownList ddlURL;
        protected System.Web.UI.WebControls.RadioButton rdEnterUrl;
        protected System.Web.UI.WebControls.TextBox txtURL;
        protected System.Web.UI.WebControls.Button btnCreate;
        protected System.Web.UI.WebControls.Label lblMsg;
        protected System.Web.UI.WebControls.HyperLink hlOpenXML;
        protected System.Web.UI.WebControls.HyperLink hlViewError;
        protected System.Web.UI.WebControls.Label lblError;

		private ResourceManager stringManager = new ResourceManager("Samples.SamplesResource",Assembly.GetExecutingAssembly());
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			
			if(!IsPostBack)
			{
				fillURLs();
				txtURL.Enabled = false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked = true;
				rdSelectUrl.Attributes.Add("OnClick","return EnableDiableURLControls();");
				rdEnterUrl.Attributes.Add("OnClick","return EnableDiableURLControls();");
                hlViewError.Attributes.Add("OnClick", "return ShowError();");
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion

		private void fillURLs()
		{
			ddlURL.Items.Add(new ListItem(stringManager.GetString("strOpml10Url"), stringManager.GetString("strOpml10Url")));
			ddlURL.Items.Add(new ListItem(stringManager.GetString("strOpml20Url"), stringManager.GetString("strOpml20Url")));					
		}

		protected void btnCreate_Click(object sender, System.EventArgs e)
		{
			try
			{
                License.LoadLicense(); 
				OpmlDoc doc; 
				lblMsg.Text = stringManager.GetString("strBlank");

				if(rdSelectUrl.Checked)
				{
					doc = OpmlDoc.Load(ddlURL.SelectedValue);
					ddlURL.Enabled = true;
					txtURL.Enabled = false;
#if(VS8)
                    ClientScript.RegisterClientScriptBlock(Type.GetType("System.String"), "", "<script language='javascript'>window.open('OpmlShowStream.aspx?url=" + ddlURL.SelectedValue + "');</script>");
#else
					Page.RegisterClientScriptBlock("","<script language='javascript'>window.open('OpmlShowStream.aspx?url=" + ddlURL.SelectedValue + "');</script>"); 					
#endif
				}	
				else
				{
                    if (!txtURL.Text.ToUpper().StartsWith("http://".ToUpper()))
                        txtURL.Text = "http://" + txtURL.Text;
					doc = OpmlDoc.Load(txtURL.Text);
					txtURL.Enabled = true;
					ddlURL.Enabled = false;
#if(VS8)
                    ClientScript.RegisterClientScriptBlock(Type.GetType("System.String"), "", "<script language='javascript'>window.open('OpmlShowStream.aspx?url=" + txtURL.Text + "');</script>");
#else
					Page.RegisterClientScriptBlock("","<script language='javascript'>window.open('OpmlShowStream.aspx?url=" + txtURL.Text+ "');</script>"); 					
#endif
				}
                hlViewError.Text = stringManager.GetString("strBlank");
                hlViewError.NavigateUrl = stringManager.GetString("strBlank");
                lblError.Text = stringManager.GetString("strBlank");
			}
			
			catch(OpmlException lex)
			{
				hlOpenXML.Text = stringManager.GetString("strBlank");	
				txtURL.Enabled = false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked = true;
				rdEnterUrl.Checked = false;

				if(lex.Message == stringManager.GetString("strUnlicensed"))
					lblMsg.Text = stringManager.GetString("strLicenseException");
				else
                    lblMsg.Text = stringManager.GetString("strErrorReading");

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = lex.Message;		
			}
            catch (InvalidLicenseException ilex)
            {
                hlOpenXML.Text = stringManager.GetString("strBlank");
                txtURL.Enabled = false;
                txtURL.Text = stringManager.GetString("strHttp");
                rdSelectUrl.Checked = true;
                rdEnterUrl.Checked = false;

                lblMsg.Text = stringManager.GetString("strLicenseException");

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ilex.Message;
            }
            catch (InvalidLicenseInfoException iliex)
            {
                hlOpenXML.Text = stringManager.GetString("strBlank");
                txtURL.Enabled = false;
                txtURL.Text = stringManager.GetString("strHttp");
                rdSelectUrl.Checked = true;
                rdEnterUrl.Checked = false;

                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo");

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = iliex.Message;
            }
			catch(Exception ex)
			{
				hlOpenXML.Text = stringManager.GetString("strBlank");	
				txtURL.Enabled = false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked = true;
				rdEnterUrl.Checked = false;

				lblMsg.Text = stringManager.GetString("strErrorReading");

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}
		}	
	}
}
