' OpmlCombine.aspx.vb
' Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.
Imports System
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports Web20Tools.Opml
Imports System.Reflection
Imports System.Resources
Imports Web20Tools.Security
Imports Web20Tools.ExceptionFramework

Namespace Samples.Opml
    ' <summary>
    ' Read multiple OPML Feeds and Aggregate into a single feed (filtered).
    ' </summary>
    Public Class OpmlCombine
        Inherits System.Web.UI.Page
        Protected Form1 As System.Web.UI.HtmlControls.HtmlForm
        Protected lblCreated As System.Web.UI.WebControls.Label
        Protected hlOpenXMLTop As System.Web.UI.WebControls.HyperLink
        Protected rdddl As System.Web.UI.WebControls.RadioButton
        Protected ddlUrls As System.Web.UI.WebControls.DropDownList
        Protected rdtxt As System.Web.UI.WebControls.RadioButton
        Protected txtEnterUrl As System.Web.UI.WebControls.TextBox
        Protected btnAddUrls As System.Web.UI.WebControls.Button
        Protected btnRemove As System.Web.UI.WebControls.Button
        Protected lbURL As System.Web.UI.WebControls.ListBox
        Protected ddlitem As System.Web.UI.WebControls.DropDownList
        Protected ddloption As System.Web.UI.WebControls.DropDownList
        Protected txtKeyword As System.Web.UI.WebControls.TextBox
        Protected btnAggregate As System.Web.UI.WebControls.Button
        Protected lblMsg As System.Web.UI.WebControls.Label
        Protected lblCreatedBottom As System.Web.UI.WebControls.Label
        Protected hlOpenXML As System.Web.UI.WebControls.HyperLink
        Protected txtHeadTitle As System.Web.UI.WebControls.TextBox
        Protected txtHeadOwner As System.Web.UI.WebControls.TextBox
        Protected hlViewError As System.Web.UI.WebControls.HyperLink
        Protected lblError As System.Web.UI.WebControls.Label
        Private stringManager As ResourceManager = New ResourceManager("Samples.SamplesResource", [Assembly].GetExecutingAssembly)

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
            If Not IsPostBack Then
                FillUrls()
                txtEnterUrl.Enabled = False
                rdddl.Checked = True
                rdddl.Attributes.Add("OnClick", "return EnableDisable();")
                rdtxt.Attributes.Add("OnClick", "return EnableDisable();")
                txtHeadTitle.Text = stringManager.GetString("strOwner")
                txtHeadOwner.Text = stringManager.GetString("strOwner")
                btnAddUrls.Attributes.Add("OnClick", "return AddUrls();")
                btnAggregate.Attributes.Add("OnClick", "return Aggregate();")
                hlViewError.Attributes.Add("OnClick", "return ShowError();")
            End If
        End Sub

        Protected Overloads Overrides Sub OnInit(ByVal e As EventArgs)
            InitializeComponent()
            MyBase.OnInit(e)
        End Sub

        Private Sub InitializeComponent()
        End Sub

        Private Sub FillUrls()
            ddlUrls.Items.Add(New ListItem(stringManager.GetString("strOpml10Url"), stringManager.GetString("strOpml10Url")))
            ddlUrls.Items.Add(New ListItem(stringManager.GetString("strOpml20Url"), stringManager.GetString("strOpml20Url")))
            ddlitem.Items.Add(New ListItem("Title", "Title"))
            ddlitem.Items.Add(New ListItem("Description", "Description"))
            ddloption.Items.Add(New ListItem("StartsWith", "StartsWith"))
            ddloption.Items.Add(New ListItem("EndsWith", "EndsWith"))
            ddloption.Items.Add(New ListItem("Contains", "Contains"))
            ddloption.Items.Add(New ListItem("Equals", "Equals"))
            ddloption.Items.Add(New ListItem("Not Equals", "NotEquals"))
        End Sub

        Protected Sub btnAddUrls_Click(ByVal sender As Object, ByVal e As System.EventArgs)
            If rdddl.Checked = True Then
                lbURL.Items.Add(ddlUrls.SelectedValue)
                txtEnterUrl.Enabled = False
                ddlUrls.Enabled = True

            Else
                If rdtxt.Checked = True Then
                    If Not txtEnterUrl.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                        txtEnterUrl.Text = "http://" + txtEnterUrl.Text
                    End If
                    lbURL.Items.Add(txtEnterUrl.Text)
                    ddlUrls.Enabled = False
                    txtEnterUrl.Enabled = True
                    txtEnterUrl.Text = stringManager.GetString("strHttp")
                End If
                End If
                lblMsg.Text = stringManager.GetString("strBlank")
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
            hlOpenXMLTop.Text = stringManager.GetString("strBlank")
            hlViewError.Text = stringManager.GetString("strBlank")
        End Sub

        Private Function FilterItem() As String
            Dim filterentry As String = String.Empty
            Select Case ddlitem.SelectedValue.ToLower
                Case "title"
                    filterentry = "title"
                Case "description"
                    filterentry = "description"
            End Select
            Return filterentry
        End Function

        Private Function FilterOperation() As String
            Dim filtertype As String = String.Empty
            Select Case ddloption.SelectedValue.ToLower
                Case "startswith"
                    filtertype = "startswith"
                Case "endswith"
                    filtertype = "endswith"
                Case "contains"
                    filtertype = "contains"
                Case "equals"
                    filtertype = "equals"
                Case "notequals"
                    filtertype = "notequals"
            End Select
            Return filtertype
        End Function

        Private Sub LoadFeeds()
            Try
                License.LoadLicense()
                Dim doc As OpmlDoc = New OpmlDoc
                doc.Version = "2.0"
                doc.Head.Title = txtHeadTitle.Text
                doc.Head.OwnerName = txtHeadOwner.Text
                doc.Head.DateCreated = DateTime.Now.ToString
                Dim i As Integer = 0
                While i < lbURL.Items.Count
                    Dim tempdoc As OpmlDoc = OpmlDoc.Load(lbURL.Items(i).Value)
                    For Each objOutline As Outline In tempdoc.Body.Outlines
                        For Each objSubOutline As Outline In objOutline.Outlines
                            If ApplyConstraint(objSubOutline) Then
                                doc.Body.Outlines.Add(objSubOutline)
                            End If
                        Next
                    Next
                    System.Math.Min(System.Threading.Interlocked.Increment(i), i - 1)
                End While
                If Not (doc.Body.Outlines.Count = 0) Then
                    Session.Add("FeedShow", doc)
                    lblCreated.Text = stringManager.GetString("strCreated")
                    lblCreatedBottom.Text = stringManager.GetString("strCreated")
                    hlOpenXML.Text = stringManager.GetString("strClick")
                    hlOpenXMLTop.Text = stringManager.GetString("strClick")
                    hlOpenXML.NavigateUrl = "OpmlShowFeed.aspx"
                    hlOpenXMLTop.NavigateUrl = "OpmlShowFeed.aspx"
                    hlOpenXML.Target = "_blank"
                    hlOpenXMLTop.Target = "_blank"
                    lblMsg.Text = stringManager.GetString("strBlank")
                Else
                    lblCreated.Text = stringManager.GetString("strBlank")
                    lblCreatedBottom.Text = stringManager.GetString("strBlank")
                    hlOpenXML.Text = stringManager.GetString("strBlank")
                    hlOpenXMLTop.Text = stringManager.GetString("strBlank")
                    lblMsg.Text = stringManager.GetString("strNoMatch")
                End If
                hlViewError.Text = stringManager.GetString("strBlank")
                hlViewError.NavigateUrl = stringManager.GetString("strBlank")
                lblError.Text = stringManager.GetString("strBlank")
            Catch lex As InvalidLicenseException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLTop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strLicenseException")
                Session("FeedShow") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = lex.Message
            Catch liex As InvalidLicenseInfoException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLTop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo")
                Session("FeedShow") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = liex.Message
            Catch ex As Exception
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLTop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strErrorCreating")
                Session("FeedShow") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            End Try
        End Sub

        Private Function ApplyConstraint(ByVal objOutline As Outline) As Boolean
            If txtKeyword.Text.Length = 0 Then
                Return True
            Else
                Dim item As String
                Dim operation As String
                item = FilterItem
                operation = FilterOperation
                If item = "title" Then
                    If Not (objOutline.Title Is Nothing) Then
                        If operation = "startswith" Then
                            If objOutline.Title.ToLower.StartsWith(txtKeyword.Text.ToLower) Then
                                Return True
                            Else
                                Return False
                            End If
                        End If
                        If operation = "endswith" Then
                            If objOutline.Title.ToLower.EndsWith(txtKeyword.Text.ToLower) Then
                                Return True
                            Else
                                Return False
                            End If
                        End If
                        If operation = "contains" Then
                            If objOutline.Title.ToLower.IndexOf(txtKeyword.Text.ToLower) = -1 Then
                                Return False
                            Else
                                Return True
                            End If
                        End If
                        If operation = "equals" Then
                            If String.Compare(objOutline.Title, txtKeyword.Text, True, System.Globalization.CultureInfo.CurrentCulture) = 0 Then
                                Return True
                            Else
                                Return False
                            End If
                        End If
                        If operation = "notequals" Then
                            If String.Compare(objOutline.Title, txtKeyword.Text, True, System.Globalization.CultureInfo.CurrentCulture) = -1 Then
                                Return True
                            Else
                                Return False
                            End If
                        End If
                    End If
                End If
                If item = "description" Then
                    If Not (objOutline.Text Is Nothing) Then
                        If operation = "startswith" Then
                            If objOutline.Description.ToLower.StartsWith(txtKeyword.Text.ToLower) Then
                                Return True
                            Else
                                Return False
                            End If
                        End If
                        If operation = "endswith" Then
                            If objOutline.Description.ToLower.EndsWith(txtKeyword.Text.ToLower) Then
                                Return True
                            Else
                                Return False
                            End If
                        End If
                        If operation = "contains" Then
                            If objOutline.Description.ToLower.IndexOf(txtKeyword.Text.ToLower) = -1 Then
                                Return False
                            Else
                                Return True
                            End If
                        End If
                        If operation = "equals" Then
                            If String.Compare(objOutline.Description, txtKeyword.Text, True, System.Globalization.CultureInfo.CurrentCulture) = 0 Then
                                Return True
                            Else
                                Return False
                            End If
                        End If
                        If operation = "notequals" Then
                            If String.Compare(objOutline.Description, txtKeyword.Text, True, System.Globalization.CultureInfo.CurrentCulture) = -1 Then
                                Return True
                            Else
                                Return False
                            End If
                        End If
                    End If
                End If
            End If
            Return False
        End Function

        Protected Sub btnAggregate_Click(ByVal sender As Object, ByVal e As System.EventArgs)
            LoadFeeds()
        End Sub

        Protected Sub btnRemove_Click(ByVal sender As Object, ByVal e As System.EventArgs)
            If lbURL.SelectedIndex > -1 Then
                lbURL.Items.Remove(lbURL.SelectedItem)
            End If
            lblMsg.Text = stringManager.GetString("strBlank")
            lblCreated.Text = stringManager.GetString("strBlank")
            lblCreatedBottom.Text = stringManager.GetString("strBlank")
            hlOpenXML.Text = stringManager.GetString("strBlank")
            hlOpenXMLTop.Text = stringManager.GetString("strBlank")
            hlViewError.Text = stringManager.GetString("strBlank")
        End Sub
    End Class
End Namespace
