' OpmlCreate.aspx.vb
' Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved. 
Imports System
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Reflection
Imports System.Resources
Imports Web20Tools.Opml
Imports Web20Tools.Security
Imports Web20Tools.ExceptionFramework
Namespace Samples.Opml
    ' <summary>
    ' Create an OPML feed.
    ' </summary>
    Public Class OpmlCreate
        Inherits System.Web.UI.Page
        Protected Form1 As System.Web.UI.HtmlControls.HtmlForm
        Protected lblCreated As System.Web.UI.WebControls.Label
        Protected hlOpenXMLtop As System.Web.UI.WebControls.HyperLink
        Protected ddlVersions As System.Web.UI.WebControls.DropDownList
        Protected btnCreate As System.Web.UI.WebControls.Button
        Protected lblMsg As System.Web.UI.WebControls.Label
        Protected lblCreatedBottom As System.Web.UI.WebControls.Label
        Protected hlOpenXML As System.Web.UI.WebControls.HyperLink
        Protected txtHeadTitle As System.Web.UI.WebControls.TextBox
        Protected txtOutlineText As System.Web.UI.WebControls.TextBox
        Protected txtOutlineDesc As System.Web.UI.WebControls.TextBox
        Protected txtOutlineTitle As System.Web.UI.WebControls.TextBox
        Protected txtOwner As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtOwnerId As System.Web.UI.WebControls.TextBox
        Protected WithEvents lblIdColon As System.Web.UI.WebControls.Label
        Protected WithEvents lblOwnerId As System.Web.UI.WebControls.Label
        Protected hlViewError As System.Web.UI.WebControls.HyperLink
        Protected lblError As System.Web.UI.WebControls.Label
        Private stringManager As ResourceManager = New ResourceManager("Samples.SamplesResource", [Assembly].GetExecutingAssembly)

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
            If Not IsPostBack Then
                ddlVersions.Attributes.Add("OnChange", "return showVersion();")
#If Not VS8 Then
                ClientScript.RegisterStartupScript(Type.GetType("System.String"), "Start", "<script language=JavaScript>showVersion();</script>")
#Else
                RegisterStartupScript("Start", "<script language=JavaScript>showVersion();</script>")
#End If
                loadDefaultValues()
                fillVersions()
                btnCreate.Attributes.Add("OnClick", "return clearLables();")
                hlViewError.Attributes.Add("OnClick", "return ShowError();")
            End If
        End Sub

        Protected Overloads Overrides Sub OnInit(ByVal e As EventArgs)
            InitializeComponent()
            MyBase.OnInit(e)
        End Sub

        Private Sub InitializeComponent()

        End Sub

        Private Sub saveOpmlFeed()
            Try
                License.LoadLicense()
                Dim doc As OpmlDoc = New OpmlDoc
                doc.Version = ddlVersions.SelectedItem.Text
                doc.Head.Title = txtHeadTitle.Text
                doc.Head.OwnerName = txtOwner.Text
                doc.Head.DateCreated = DateTime.Now.ToString
                If ddlVersions.SelectedItem.Text.Equals("2.0") Then
                    If Not txtOwnerId.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                        txtOwnerId.Text = "http://" + txtOwnerId.Text
                    End If
                    doc.Head.OwnerId = txtOwnerId.Text
                End If
                Dim objOutline As Outline = New Outline
                objOutline.Text = txtOutlineText.Text
                objOutline.Title = txtOutlineTitle.Text
                objOutline.Description = txtOutlineDesc.Text
                doc.Body.Outlines.Add(objOutline)
                Session.Add("FeedShow", doc)
                lblCreated.Text = stringManager.GetString("strCreated")
                lblCreatedBottom.Text = stringManager.GetString("strCreated")
                hlOpenXML.Text = stringManager.GetString("strClick")
                hlOpenXMLtop.Text = stringManager.GetString("strClick")
                hlOpenXML.NavigateUrl = "OpmlShowFeed.aspx"
                hlOpenXMLtop.NavigateUrl = "OpmlShowFeed.aspx"
                hlOpenXML.Target = "_blank"
                hlOpenXMLtop.Target = "_blank"
                lblMsg.Text = stringManager.GetString("strBlank")

                hlViewError.Text = stringManager.GetString("strBlank")
                hlViewError.NavigateUrl = stringManager.GetString("strBlank")
                lblError.Text = stringManager.GetString("strBlank")
            Catch lex As InvalidLicenseException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strLicenseException")
                Session("FeedShow") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = lex.Message
            Catch liex As InvalidLicenseInfoException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo")
                Session("FeedShow") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = liex.Message
            Catch ex As Exception
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strErrorCreating")
                Session("FeedShow") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            End Try
        End Sub

        Private Sub loadDefaultValues()
            txtHeadTitle.Text = stringManager.GetString("strHeadTitle")
            txtOwner.Text = stringManager.GetString("strOwner")
            txtOwnerId.Text = stringManager.GetString("strOwnerId")
            txtOutlineText.Text = stringManager.GetString("strText")
            txtOutlineTitle.Text = stringManager.GetString("strTitle")
            txtOutlineDesc.Text = stringManager.GetString("strDesc")
        End Sub

        Private Sub fillVersions()
            ddlVersions.Items.Add("1.0")
            ddlVersions.Items.Add("2.0")
        End Sub

        Protected Sub btnCreate_Click(ByVal sender As Object, ByVal e As System.EventArgs)
            saveOpmlFeed()
#If Not VS8 Then
            ClientScript.RegisterStartupScript(Type.GetType("System.String"), "Start", "<script language=JavaScript>showVersionDiv();</script>")
#Else
            RegisterStartupScript("Start", "<script language=JavaScript>showVersionDiv();</script>")
#End If
        End Sub
    End Class
End Namespace
