' OpmlLoad.aspx.vb
' Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved. 
Imports System
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Net
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports Web20Tools.Opml
Imports System.Reflection
Imports System.Resources
Imports System.Text
Imports Web20Tools.Security
Imports Web20Tools.ExceptionFramework
Namespace Samples.Opml
    ' <summary>
    ' Read and display different versions of OPML feeds.
    ' </summary>
    Public Class OpmlLoad
        Inherits System.Web.UI.Page
        Protected SampleForm As System.Web.UI.HtmlControls.HtmlForm
        Protected rdSelectUrl As System.Web.UI.WebControls.RadioButton
        Protected ddlURL As System.Web.UI.WebControls.DropDownList
        Protected rdEnterUrl As System.Web.UI.WebControls.RadioButton
        Protected txtUrl As System.Web.UI.WebControls.TextBox
        Protected btnLoad As System.Web.UI.WebControls.Button
        Protected lblMsg As System.Web.UI.WebControls.Label
        Protected lblFeed As System.Web.UI.WebControls.Label
        Protected dgRssFeed As System.Web.UI.WebControls.DataGrid
        Protected lblEntry As System.Web.UI.WebControls.Label
        Protected dgItem As System.Web.UI.WebControls.DataGrid
        Protected hlViewError As System.Web.UI.WebControls.HyperLink
        Protected lblError As System.Web.UI.WebControls.Label
        Private stringManager As ResourceManager = New ResourceManager("Samples.SamplesResource", [Assembly].GetExecutingAssembly())

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
            If Not IsPostBack Then
                LoadAttributes()
                hlViewError.Attributes.Add("OnClick", "return ShowError();")
            End If
        End Sub

        Protected Overloads Overrides Sub OnInit(ByVal e As EventArgs)
            InitializeComponent()
            MyBase.OnInit(e)
        End Sub

        Private Sub InitializeComponent()
            AddHandler Me.dgRssFeed.ItemCreated, AddressOf Me.dgRssFeed_ItemCreated
            AddHandler Me.dgItem.ItemCreated, AddressOf Me.dgItem_ItemCreated
        End Sub

        Protected Sub btnLoad_Click(ByVal sender As Object, ByVal e As System.EventArgs)
            Dim doc As OpmlDoc = Nothing
            Dim ds As DataSet = New DataSet
            ds.Locale = System.Globalization.CultureInfo.InvariantCulture
            Try
                License.LoadLicense()
                If rdSelectUrl.Checked Then
                    doc = OpmlDoc.Load(ddlURL.SelectedValue.ToString)
                    ddlURL.Enabled = True
                    txtUrl.Enabled = False
                    txtUrl.Text = stringManager.GetString("strHttp")
                Else
                    If Not txtUrl.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                        txtUrl.Text = "http://" + txtUrl.Text
                    End If
                    doc = OpmlDoc.Load(txtUrl.Text)
                    txtUrl.Enabled = True
                    ddlURL.Enabled = False
                    End If
                    ds = OpmlLoadGrid(doc)
                    dgRssFeed.DataSource = ds.Tables(0)
                    dgRssFeed.DataBind()
                    dgItem.DataSource = ds.Tables(1)
                    dgItem.DataBind()
                    lblFeed.Text = stringManager.GetString("strHeadGridTitle")
                    lblEntry.Text = stringManager.GetString("strBodyGridTitle")
                    dgRssFeed.Visible = True
                    dgItem.Visible = True
                lblMsg.Text = stringManager.GetString("strBlank")

                hlViewError.Text = stringManager.GetString("strBlank")
                hlViewError.NavigateUrl = stringManager.GetString("strBlank")
                lblError.Text = stringManager.GetString("strBlank")
                    Response.Write("<script language=javascript>window.navigate('#bm');</script>")
            Catch ex As OpmlException
                txtUrl.Enabled = False
                txtUrl.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                If ex.Message = stringManager.GetString("strUnlicensed") Then
                    lblMsg.Text = stringManager.GetString("strLicenseException")
                Else
                    lblMsg.Text = stringManager.GetString("strErrorReading")
                End If
                lblFeed.Text = stringManager.GetString("strBlank")
                lblEntry.Text = stringManager.GetString("strBlank")
                dgRssFeed.Visible = False
                dgItem.Visible = False

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            Catch lex As InvalidLicenseInfoException
                txtUrl.Enabled = False
                txtUrl.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo")
                lblFeed.Text = stringManager.GetString("strBlank")
                lblEntry.Text = stringManager.GetString("strBlank")
                dgRssFeed.Visible = False
                dgItem.Visible = False
                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = lex.Message
            Catch liex As InvalidLicenseException
                txtUrl.Enabled = False
                txtUrl.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = stringManager.GetString("strLicenseException")
                lblFeed.Text = stringManager.GetString("strBlank")
                lblEntry.Text = stringManager.GetString("strBlank")
                dgRssFeed.Visible = False
                dgItem.Visible = False
                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = liex.Message
            Catch ex As Exception
                ex.Message.ToString()
                txtUrl.Enabled = False
                txtUrl.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = stringManager.GetString("strErrorReading")
                lblFeed.Text = stringManager.GetString("strBlank")
                lblEntry.Text = stringManager.GetString("strBlank")
                dgRssFeed.Visible = False
                dgItem.Visible = False
                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            End Try
        End Sub

        Private Function OpmlLoadGrid(ByVal doc As OpmlDoc) As DataSet
            Dim dsOpml As DataSet = New DataSet
            dsOpml.Locale = System.Globalization.CultureInfo.InvariantCulture
            Dim dt As DataTable = New DataTable("OpmlTable")
            dt.Locale = System.Globalization.CultureInfo.InvariantCulture
            Dim dti As DataTable = New DataTable("OutlineTable")
            dti.Locale = System.Globalization.CultureInfo.InvariantCulture
            Dim tagCol As DataColumn = New DataColumn("Element", System.Type.GetType("System.String"))
            dt.Columns.Add(tagCol)
            Dim attributeCol As DataColumn = New DataColumn("Attribute/Tag", System.Type.GetType("System.String"))
            dt.Columns.Add(attributeCol)
            Dim valueCol As DataColumn = New DataColumn("Value", System.Type.GetType("System.String"))
            dt.Columns.Add(valueCol)
            Dim dr As DataRow
            dr = dt.NewRow
            dr("Attribute/Tag") = "Version"
            dr("Value") = doc.Version
            dt.Rows.Add(dr)
            If Not (doc.Head.Title Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "Title"
                dr("Value") = doc.Head.Title
                dt.Rows.Add(dr)
            End If
            If Not (doc.Head.DateCreated Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "Date Created"
                dr("Value") = doc.Head.DateCreated
                dt.Rows.Add(dr)
            End If
            If Not (doc.Head.DateModified Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "Date Modified"
                dr("Value") = doc.Head.DateModified
                dt.Rows.Add(dr)
            End If
            If Not (doc.Head.OwnerName Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "Owner Name"
                dr("Value") = doc.Head.OwnerName
                dt.Rows.Add(dr)
            End If
            If Not (doc.Head.OwnerEmail Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "Owner Email"
                dr("Value") = doc.Head.OwnerEmail
                dt.Rows.Add(dr)
            End If
            If Not (doc.Head.ExpansionState Is Nothing) Then
                If Not (doc.Head.ExpansionState.Length = 0) Then
                    dr = dt.NewRow
                    dr("Element") = "Expansion State"
                    dr("Value") = doc.Head.ExpansionState
                    dt.Rows.Add(dr)
                End If
            End If
            If Not (doc.Head.VertScrollState Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "VertScrollState"
                dr("Value") = doc.Head.VertScrollState
                dt.Rows.Add(dr)
            End If
            If Not (doc.Head.WindowTop Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "Window Top"
                dr("Value") = doc.Head.WindowTop
                dt.Rows.Add(dr)
            End If
            If Not (doc.Head.WindowLeft Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "Window Left"
                dr("Value") = doc.Head.WindowLeft
                dt.Rows.Add(dr)
            End If
            If Not (doc.Head.WindowBottom Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "Window Bottom"
                dr("Value") = doc.Head.WindowBottom
                dt.Rows.Add(dr)
            End If
            If Not (doc.Head.WindowRight Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "Window Right"
                dr("Value") = doc.Head.WindowRight
                dt.Rows.Add(dr)
            End If
            If Not (doc.Head.OwnerId Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "Owner Id"
                dr("Value") = doc.Head.OwnerId
                dt.Rows.Add(dr)
            End If
            If Not (doc.Head.Docs Is Nothing) Then
                dr = dt.NewRow
                dr("Element") = "Docs"
                dr("Value") = doc.Head.Docs
                dt.Rows.Add(dr)
            End If
            dti = OpmlGridOutline(doc.Body.Outlines)
            dsOpml.Tables.Add(dt)
            dsOpml.Tables.Add(dti)
            Return dsOpml
        End Function

        Private Function OpmlGridOutline(ByVal outlineCol As OutlineCollection) As DataTable
            Dim dti As DataTable = New DataTable
            dti.Locale = System.Globalization.CultureInfo.InvariantCulture
            Dim tagCol As DataColumn = New DataColumn("Element", System.Type.GetType("System.String"))
            dti.Columns.Add(tagCol)
            Dim attributeCol As DataColumn = New DataColumn("Attribute/Tag", System.Type.GetType("System.String"))
            dti.Columns.Add(attributeCol)
            Dim valueCol As DataColumn = New DataColumn("Value", System.Type.GetType("System.String"))
            dti.Columns.Add(valueCol)
            Dim dr As DataRow
            For Each objOutline As Outline In outlineCol
                dr = dti.NewRow
                dr("Element") = "Outline"
                dti.Rows.Add(dr)
                If Not (objOutline.Title Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "Title"
                    dr("Value") = objOutline.Title
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.Text Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "Text"
                    dr("Value") = XMLEncoding(objOutline.Text)
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.Description Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "Description"
                    dr("Value") = XMLEncoding(objOutline.Description)
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.Type Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "Type"
                    dr("Value") = objOutline.Type
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.Language Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "Languge"
                    dr("Value") = objOutline.Language
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.Version Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "Version"
                    dr("Value") = objOutline.Version
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.Category Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "Category"
                    dr("Value") = objOutline.Category
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.HTMLURL Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "Html Url"
                    dr("Value") = objOutline.HTMLURL
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.XMLURL Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "Xml Url"
                    dr("Value") = objOutline.XMLURL
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.Created Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "Created"
                    dr("Value") = objOutline.Created
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.IsBreakPoint Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "IsBreakPoint"
                    dr("Value") = objOutline.IsBreakPoint
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.IsComment Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "IsComment"
                    dr("Value") = objOutline.IsComment
                    dti.Rows.Add(dr)
                End If
                If Not (objOutline.Url Is Nothing) Then
                    dr = dti.NewRow
                    dr("Attribute/Tag") = "Url"
                    dr("Value") = objOutline.Url
                    dti.Rows.Add(dr)
                End If
                Exit For
            Next
            Return dti
        End Function

        Private Sub dgRssFeed_ItemCreated(ByVal sender As Object, ByVal e As DataGridItemEventArgs)
            If e.Item.ItemType = ListItemType.Item OrElse e.Item.ItemType = ListItemType.AlternatingItem Then
                e.Item.Cells(0).Width = Unit.Percentage(15)
                e.Item.Cells(0).BackColor = System.Drawing.Color.Cornsilk
                e.Item.Cells(1).Width = Unit.Percentage(15)
                e.Item.Cells(1).ForeColor = System.Drawing.Color.Blue
                e.Item.Cells(2).Width = Unit.Percentage(70)
                e.Item.Cells(2).ForeColor = System.Drawing.Color.Red
            End If
        End Sub

        Private Sub dgItem_ItemCreated(ByVal sender As Object, ByVal e As DataGridItemEventArgs)
            If e.Item.ItemType = ListItemType.Item OrElse e.Item.ItemType = ListItemType.AlternatingItem Then
                e.Item.Cells(0).Width = Unit.Percentage(15)
                e.Item.Cells(0).BackColor = System.Drawing.Color.Cornsilk
                e.Item.Cells(1).Width = Unit.Percentage(15)
                e.Item.Cells(1).ForeColor = System.Drawing.Color.Blue
                e.Item.Cells(2).Width = Unit.Percentage(70)
                e.Item.Cells(2).ForeColor = System.Drawing.Color.Red
            End If
        End Sub

        Private Sub LoadAttributes()
            fillURLs()
            txtUrl.Enabled = False
            txtUrl.Text = stringManager.GetString("strHttp")
            rdSelectUrl.Checked = True
            lblFeed.Text = stringManager.GetString("strBlank")
            lblEntry.Text = stringManager.GetString("strBlank")
            rdSelectUrl.Attributes.Add("OnClick", "return EnableDisableURLControls();")
            rdEnterUrl.Attributes.Add("OnClick", "return EnableDisableURLControls();")
            btnLoad.Attributes.Add("OnClick", "return checkURL();")
        End Sub

        Private Sub fillURLs()
            ddlURL.Items.Add(New ListItem(stringManager.GetString("strOpml10Url"), stringManager.GetString("strOpml10Url")))
            ddlURL.Items.Add(New ListItem(stringManager.GetString("strOpml20Url"), stringManager.GetString("strOpml20Url")))
        End Sub

        Private Function XMLEncoding(ByVal stitle As String) As String
            Dim strBuild As StringBuilder = New StringBuilder(stitle)
            strBuild.Replace("&amp;", "").Replace("&apos;", "'").Replace("&quot;", """").Replace("&lt;", "<").Replace("&gt;", ">").Replace("" & Microsoft.VisualBasic.Chr(10) & "", "").Replace("" & Microsoft.VisualBasic.Chr(13) & "", "")
            Return strBuild.ToString.Trim
        End Function
    End Class
End Namespace
