' OpmlStream.aspx.vb
' Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved. 
Imports System
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports Web20Tools.Opml
Imports System.Reflection
Imports System.Resources
Imports Web20Tools.Security
Imports Web20Tools.ExceptionFramework
Namespace Samples.Opml
    ' <summary>
    ' Write an OPML Feed to an HTTP Response Stream.
    ' </summary>
    Public Class OpmlStream
        Inherits System.Web.UI.Page
        Protected Form1 As System.Web.UI.HtmlControls.HtmlForm
        Protected rdSelectUrl As System.Web.UI.WebControls.RadioButton
        Protected ddlURL As System.Web.UI.WebControls.DropDownList
        Protected rdEnterUrl As System.Web.UI.WebControls.RadioButton
        Protected txtURL As System.Web.UI.WebControls.TextBox
        Protected btnCreate As System.Web.UI.WebControls.Button
        Protected lblMsg As System.Web.UI.WebControls.Label
        Protected hlOpenXML As System.Web.UI.WebControls.HyperLink
        Protected hlViewError As System.Web.UI.WebControls.HyperLink
        Protected lblError As System.Web.UI.WebControls.Label
        Private stringManager As ResourceManager = New ResourceManager("Samples.SamplesResource", [Assembly].GetExecutingAssembly)

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
            If Not IsPostBack Then
                fillURLs()
                txtURL.Enabled = False
                txtURL.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdSelectUrl.Attributes.Add("OnClick", "return EnableDiableURLControls();")
                rdEnterUrl.Attributes.Add("OnClick", "return EnableDiableURLControls();")
                hlViewError.Attributes.Add("OnClick", "return ShowError();")
            End If
        End Sub

        Protected Overloads Overrides Sub OnInit(ByVal e As EventArgs)
            InitializeComponent()
            MyBase.OnInit(e)
        End Sub

        Private Sub InitializeComponent()
        End Sub

        Private Sub fillURLs()
            ddlURL.Items.Add(New ListItem(stringManager.GetString("strOpml10Url"), stringManager.GetString("strOpml10Url")))
            ddlURL.Items.Add(New ListItem(stringManager.GetString("strOpml20Url"), stringManager.GetString("strOpml20Url")))
        End Sub

        Protected Sub btnCreate_Click(ByVal sender As Object, ByVal e As System.EventArgs)
            Try
                License.LoadLicense()
                Dim doc As OpmlDoc
                lblMsg.Text = stringManager.GetString("strBlank")
                If rdSelectUrl.Checked Then
                    doc = OpmlDoc.Load(ddlURL.SelectedValue)
                    ddlURL.Enabled = True
                    txtURL.Enabled = False
#If Not (VS8) Then
                    ClientScript.RegisterClientScriptBlock(Type.GetType("System.String"), "", "<script language='javascript'>window.open('OpmlShowStream.aspx?url=" + ddlURL.SelectedValue + "');</script>")
#Else
                    Page.RegisterClientScriptBlock("", "<script language='javascript'>window.open('OpmlShowStream.aspx?url=" + ddlURL.SelectedValue + "');</script>")
#End If
                Else
                    If Not txtURL.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                        txtURL.Text = "http://" + txtURL.Text
                    End If
                    doc = OpmlDoc.Load(txtURL.Text)
                    txtURL.Enabled = True
                    ddlURL.Enabled = False
#If Not (VS8) Then
                    ClientScript.RegisterClientScriptBlock(Type.GetType("System.String"), "", "<script language='javascript'>window.open('OpmlShowStream.aspx?url=" + txtURL.Text + "');</script>")
#Else
                    Page.RegisterClientScriptBlock("", "<script language='javascript'>window.open('OpmlShowStream.aspx?url=" + txtURL.Text + "');</script>")
#End If
                End If
                hlViewError.Text = stringManager.GetString("strBlank")
                hlViewError.NavigateUrl = stringManager.GetString("strBlank")
                lblError.Text = stringManager.GetString("strBlank")

            Catch lex As OpmlException
                hlOpenXML.Text = stringManager.GetString("strBlank")
                txtURL.Enabled = False
                txtURL.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                If lex.Message = stringManager.GetString("strUnlicensed") Then
                    lblMsg.Text = stringManager.GetString("strLicenseException")
                Else
                    lblMsg.Text = stringManager.GetString("strErrorReading")
                End If

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = lex.Message
            Catch ex As InvalidLicenseException
                hlOpenXML.Text = stringManager.GetString("strBlank")
                txtURL.Enabled = False
                txtURL.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = stringManager.GetString("strLicenseException")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            Catch liex As InvalidLicenseInfoException
                hlOpenXML.Text = stringManager.GetString("strBlank")
                txtURL.Enabled = False
                txtURL.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = liex.Message
            Catch ex As Exception
                hlOpenXML.Text = stringManager.GetString("strBlank")
                txtURL.Enabled = False
                txtURL.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = stringManager.GetString("strErrorReading")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            End Try
        End Sub
    End Class
End Namespace
