/*
	* OpmDocument.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved. 
*/

using System;
using System.Text;
using System.Text.RegularExpressions;
using Web20Tools.Opml;

namespace OpmlLoad
{
    class OpmlDocument
    {
        private StringBuilder strData;
        private const int range = 45;
        private const int lowRange = 43;

        #region CheckUrl
        public static bool CheckUrl(string surl)
        {
            if (surl != null)
            {
                Regex RgxUrl = new Regex("(([a-zA-Z][0-9a-zA-Z+\\-\\.]*:)?/{0,2}[0-9a-zA-Z;/?:@&=+$\\.\\-_!~*'()%]+)?(#[0-9a-zA-Z;/?:@&=+$\\.\\-_!~*'()%]+)?");

                if (!RgxUrl.IsMatch(surl))
                {
                    return false;
                }
                else
                {
                    return true;

                }
            }
            else
            {
                return false;
            }
        }
        #endregion

        public string DisplayDoc(OpmlDoc doc)
        {
            strData = new StringBuilder();            
                
            strData.Append("OPML  " + Environment.NewLine);
            if(doc.Version != null)
                strData.Append(" Version\t: " + doc.Version  + Environment.NewLine);
            
            strData.Append(" Head " + Environment.NewLine);

            if (doc.Head.Title != null)
            {
                if (doc.Head.Title.Length > range)
                {
                    strData.Append("   Title\t: " + XMLEncoding(doc.Head.Title.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   Title\t: " + doc.Head.Title + Environment.NewLine);
                }
            }

            if (doc.Head.DateCreated != null)
            {
                if (doc.Head.DateCreated.Length > range)
                {
                    strData.Append("   DateCreated\t: " + XMLEncoding(doc.Head.DateCreated.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   DateCreated\t: " + doc.Head.DateCreated.ToString() + Environment.NewLine);
                }
            }

            if (doc.Head.DateModified != null)
            {
                if (doc.Head.DateModified.Length > range)
                {
                    strData.Append("   DateModified\t: " + XMLEncoding(doc.Head.DateModified.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   DateModified\t: " + doc.Head.DateModified + Environment.NewLine);
                }
            }

            if (doc.Head.OwnerName != null)
            {
                if (doc.Head.OwnerName.Length > range)
                {
                    strData.Append("   OwnerName\t: " + XMLEncoding(doc.Head.OwnerName.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   OwnerName\t: " + doc.Head.OwnerName + Environment.NewLine);
                }
            }

            if (doc.Head.OwnerEmail != null)
            {
                if (doc.Head.OwnerEmail.Length > range)
                {
                    strData.Append("   OwnerEmail\t: " + XMLEncoding(doc.Head.OwnerEmail.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   OwnerEmail\t: " + doc.Head.OwnerEmail + Environment.NewLine);
                }
            }

            if (doc.Head.ExpansionState != null)
            {
                if (doc.Head.ExpansionState.Length > range)
                {
                    strData.Append("   ExState\t: " + XMLEncoding(doc.Head.ExpansionState.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    if (doc.Head.ExpansionState.Length != 0)
                        strData.Append("   ExState\t: " + doc.Head.ExpansionState + Environment.NewLine);
                }
            }

            if (doc.Head.VertScrollState != null)
            {
                if (doc.Head.VertScrollState.Length > range)
                {
                    strData.Append("   VScrollState\t: " + XMLEncoding(doc.Head.VertScrollState.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   VScrollState\t: " + doc.Head.VertScrollState + Environment.NewLine);
                }
            }

            if (doc.Head.WindowTop != null)
            {
                if (doc.Head.WindowTop.Length > range)
                {
                    strData.Append("   WindowTop\t: " + XMLEncoding(doc.Head.WindowTop.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   WindowTop\t: " + doc.Head.WindowTop + Environment.NewLine);
                }
            }

            if (doc.Head.WindowLeft != null)
            {
                if (doc.Head.WindowLeft.Length > range)
                {
                    strData.Append("   WindowLeft\t: " + XMLEncoding(doc.Head.WindowLeft.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   WindowLeft\t: " + doc.Head.WindowLeft + Environment.NewLine);
                }
            }

            if (doc.Head.WindowBottom != null)
            {
                if (doc.Head.WindowBottom.Length > range)
                {
                    strData.Append("   WindowBottom\t: " + XMLEncoding(doc.Head.WindowBottom.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   WindowBottom\t: " + doc.Head.WindowBottom + Environment.NewLine);
                }
            }

            if (doc.Head.WindowRight != null)
            {
                if (doc.Head.WindowRight.Length > range)
                {
                    strData.Append("   WindowRight\t: " + XMLEncoding(doc.Head.WindowRight.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   WindowRight\t: " + doc.Head.WindowRight + Environment.NewLine);
                }
            }

            if (doc.Head.OwnerId != null)
            {
                if (doc.Head.OwnerId.Length > range)
                {
                    strData.Append("   OwnerId\t: " + XMLEncoding(doc.Head.OwnerId.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   OwnerId\t: " + doc.Head.OwnerId + Environment.NewLine);
                }

            }

            if (doc.Head.Docs != null)
            {
                if (doc.Head.Docs.Length > range)
                {
                    strData.Append("   Docs\t\t: " + XMLEncoding(doc.Head.Docs.Substring(0, range)) + "..." + Environment.NewLine);
                }
                else
                {
                    strData.Append("   Docs\t\t: " + doc.Head.Docs + Environment.NewLine);
                }
            }
            strData.Append(Environment.NewLine);
            strData.Append(" Body" + Environment.NewLine);
            DisplayOutline(doc.Body.Outlines);

            return strData.ToString();
        }

        private void DisplayOutline(OutlineCollection outlineCol)
        {
            foreach (Outline objOutline in outlineCol)
            {                
                strData.Append("   Outline" + Environment.NewLine);

                if (objOutline.Title != null)
                {
                    if (objOutline.Title.Length > lowRange)
                    {
                        strData.Append("    Title\t: " + XMLEncoding(objOutline.Title.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    Title\t: " + objOutline.Title + Environment.NewLine);
                    }
                }
                if (objOutline.Text != null)
                {
                    if (objOutline.Text.Length > lowRange)
                    {
                        strData.Append("    Text\t: " + XMLEncoding(objOutline.Text.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    Text\t: " + objOutline.Text + Environment.NewLine);
                    }
                }

                if (objOutline.Description != null)
                {
                    if (objOutline.Description.Length > lowRange)
                    {
                        strData.Append("    Description\t: " + XMLEncoding(objOutline.Description.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    Description\t: " + objOutline.Description + Environment.NewLine);
                    }
                }
                if (objOutline.Type != null)
                {
                    if (objOutline.Type.Length > lowRange)
                    {
                        strData.Append("    Type\t: " + XMLEncoding(objOutline.Type.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    Type\t: " + objOutline.Type + Environment.NewLine);
                    }
                }
                if (objOutline.Language != null)
                {
                    if (objOutline.Language.Length > lowRange)
                    {
                        strData.Append("    Language\t: " + XMLEncoding(objOutline.Language.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    Language\t: " + objOutline.Language + Environment.NewLine);
                    }
                }
                if (objOutline.Version != null)
                {
                    if (objOutline.Version.Length > lowRange)
                    {
                        strData.Append("    Version\t: " + XMLEncoding(objOutline.Version.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    Version\t: " + objOutline.Version + Environment.NewLine);
                    }
                }

                if (objOutline.Category != null)
                {
                    if (objOutline.Category.Length > lowRange)
                    {
                        strData.Append("    Category\t: " + XMLEncoding(objOutline.Category.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    Category\t: " + objOutline.Category + Environment.NewLine);
                    }
                }

                if (objOutline.HTMLURL != null)
                {
                    if (objOutline.HTMLURL.Length > lowRange)
                    {
                        strData.Append("    HtmlUrl\t: " + XMLEncoding(objOutline.HTMLURL.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    HtmlUrl\t: " + objOutline.HTMLURL + Environment.NewLine);
                    }
                }

                if (objOutline.XMLURL != null)
                {
                    if (objOutline.XMLURL.Length > lowRange)
                    {
                        strData.Append("    XmlUrl\t: " + XMLEncoding(objOutline.XMLURL.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    XmlUrl\t: " + objOutline.XMLURL + Environment.NewLine);
                    }
                }

                if (objOutline.Created != null)
                {
                    if (objOutline.Created.Length > lowRange)
                    {
                        strData.Append("    Created\t: " + XMLEncoding(objOutline.Created.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    Created\t: " + objOutline.Created + Environment.NewLine);
                    }
                }
                if (objOutline.IsBreakPoint != null)
                {
                    if (objOutline.IsBreakPoint.Length > lowRange)
                    {
                        strData.Append("    IsBreakPoint: " + XMLEncoding(objOutline.IsBreakPoint.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    IsBreakPoint: " + objOutline.IsBreakPoint + Environment.NewLine);
                    }
                }
                if (objOutline.IsComment != null)
                {
                    if (objOutline.IsComment.Length > lowRange)
                    {
                        strData.Append("    IsComment\t: " + XMLEncoding(objOutline.IsComment.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    IsComment\t: " + objOutline.IsComment + Environment.NewLine);
                    }
                }
                if (objOutline.Url != null)
                {
                    if (objOutline.Url.Length > lowRange)
                    {
                        strData.Append("    Url\t\t: " + XMLEncoding(objOutline.Url.Substring(0, lowRange)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("    Url\t\t: " + objOutline.Url + Environment.NewLine);
                    }
                }


                if (objOutline.Outlines.Count != 0)
                {
                    DisplayInnerOutline(objOutline.Outlines, 4); 
                }
                strData.Append(Environment.NewLine);

            }
        }

        private void DisplayInnerOutline(OutlineCollection outlineCol, int space)
        {
            StringBuilder forwardSpace = new StringBuilder(); 
            for (int i = 0; i < space; i++)
            {
                forwardSpace.Append(" ");
            }
            foreach (Outline objOutline in outlineCol)
            {
                strData.Append(Environment.NewLine);
                strData.Append(forwardSpace + "Outline" + Environment.NewLine);

                if (objOutline.Title != null)
                {
                    if (objOutline.Title.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " Title       : " + XMLEncoding(objOutline.Title.Substring(0, (lowRange - forwardSpace.Length ))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " Title       : " + objOutline.Title + Environment.NewLine);
                    }
                }
                if (objOutline.Text != null)
                {
                    if (objOutline.Text.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " Text        : " + XMLEncoding(objOutline.Text.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " Text        : " + objOutline.Text + Environment.NewLine);
                    }
                }

                if (objOutline.Description != null)
                {
                    if (objOutline.Description.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " Description : " + XMLEncoding(objOutline.Description.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " Description : " + objOutline.Description + Environment.NewLine);
                    }
                }
                if (objOutline.Type != null)
                {
                    if (objOutline.Type.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " Type        : " + XMLEncoding(objOutline.Type.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " Type        : " + objOutline.Type + Environment.NewLine);
                    }
                }
                if (objOutline.Language != null)
                {
                    if (objOutline.Language.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " Language    : " + XMLEncoding(objOutline.Language.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " Language    : " + objOutline.Language + Environment.NewLine);
                    }
                }
                if (objOutline.Version != null)
                {
                    if (objOutline.Version.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace + " Version     : " + XMLEncoding(objOutline.Version.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " Version     : " + objOutline.Version + Environment.NewLine);
                    }
                }

                if (objOutline.Category != null)
                {
                    if (objOutline.Category.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " Category    : " + XMLEncoding(objOutline.Category.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " Category    : " + objOutline.Category + Environment.NewLine);
                    }
                }

                if (objOutline.HTMLURL != null)
                {
                    if (objOutline.HTMLURL.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " HtmlUrl     : " + XMLEncoding(objOutline.HTMLURL.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " HtmlUrl     : " + objOutline.HTMLURL + Environment.NewLine);
                    }
                }

                if (objOutline.XMLURL != null)
                {
                    if (objOutline.XMLURL.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " XmlUrl      : " + XMLEncoding(objOutline.XMLURL.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " XmlUrl      : " + objOutline.XMLURL + Environment.NewLine);
                    }
                }

                if (objOutline.Created != null)
                {
                    if (objOutline.Created.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " Created     : " + XMLEncoding(objOutline.Created.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " Created     : " + objOutline.Created + Environment.NewLine);
                    }
                }
                if (objOutline.IsBreakPoint != null)
                {
                    if (objOutline.IsBreakPoint.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " IsBreakPoint: " + XMLEncoding(objOutline.IsBreakPoint.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " IsBreakPoint: " + objOutline.IsBreakPoint + Environment.NewLine);
                    }
                }
                if (objOutline.IsComment != null)
                {
                    if (objOutline.IsComment.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " IsComment   : " + XMLEncoding(objOutline.IsComment.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " IsComment   : " + objOutline.IsComment + Environment.NewLine);
                    }
                }
                if (objOutline.Url != null)
                {
                    if (objOutline.Url.Length > (lowRange - forwardSpace.Length))
                    {
                        strData.Append(forwardSpace.ToString() + " Url         : " + XMLEncoding(objOutline.Url.Substring(0, (lowRange - forwardSpace.Length))) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append(forwardSpace.ToString() + " Url         : " + objOutline.Url + Environment.NewLine);
                    }
                }
            
                if (objOutline.Outlines.Count != 0)
                {
                    DisplayInnerOutline(objOutline.Outlines, space+1);
                }
            }
        }

        #region Encoding
        private string XMLEncoding(string stitle)
        {
            StringBuilder strBuild = new StringBuilder(stitle);

            strBuild.Replace("&amp;", "")
               .Replace("&apos;", "'")
               .Replace("&quot;", "\"")
               .Replace("&lt;", "<")
               .Replace("&gt;", ">")
               .Replace("\n", "")
               .Replace("\r", "");

            return strBuild.ToString().Trim();

        }
        #endregion

    }
}
